//============================================================================
// 533I2C_WinTest Code.
// Copyright 2001-2004, Crystalfontz America, Inc. Written by Brent A. Crosby
//
// You may use this code in any project (including commercial) as long as
// at least one of the intents of the project is to communicate with a
// Crystalfontz display.
//
// http://www.crystalfontz.com brent@crystalfontz.com
//
// !!!!!!!! THIS IS TEST CODE ONLY !!!!!!!!
// !!!!!!!!  USE AT YOUR OWN RISK  !!!!!!!!
//
//============================================================================
#include "stdafx.h"
#include "I2C.h"
//============================================================================
//Only included to access ti I2C status field in main window
#include "533I2C_wintest.h"
#include "GPIO.h"
#include "KeyPads.h"
#include "TempsDlg.h"
#include "Packet_Debug.h"
#include "Live_Display.h"
#include "533I2C_WinTestDlg.h"
//------------------------------------------------------------------------------
CWnd
  *OurParent=NULL;
/*---------------------------------------------------------------------------*/

AARDVARK_PORTS
  ports[128];
int
  number_of_ports;
int
  selected_port;
Aardvark
  aardvark_handle;

/*---------------------------------------------------------------------------*/
void Set_I2C_Parent(CWnd* pParent)
  {
  OurParent=pParent;
  }
/*---------------------------------------------------------------------------*/
void I2C_Init(void)
  {
	// Ensure that the I2C subsystem is enabled
	aa_configure(aardvark_handle,  AA_CONFIG_SPI_I2C);

	// Enable the I2C bus pullup resistors (2.2k resistors).
	// This command is only effective on v2.0 hardware or greater.
	// The pullup resistors on the v1.02 hardware are enabled by default.
	aa_i2c_pullup(aardvark_handle, AA_I2C_PULLUP_BOTH);

	aa_target_power(aardvark_handle, AA_TARGET_POWER_BOTH);

	// Set the bitrate
	aa_i2c_bitrate(aardvark_handle, 400);
  }
//------------------------------------------------------------------------------
void Uninit_I2C()
  {
	aa_target_power(aardvark_handle, AA_TARGET_POWER_NONE);
  }
/*---------------------------------------------------------------------------*/ 
#define CLEAN_CRC_SOURCE 0

#if CLEAN_CRC_SOURCE

word get_crc(ubyte *bufptr,word len)
  {
  register unsigned int
    newCRC;
  //Put the current byte in here.
  ubyte
    data;
  int
    bit_count;
  //This seed makes the output of this shift based algorithm match
  //the table based algorithm. The center 16 bytes of the 32-bit
  //"newCRC" are used for the CRC. The MSb of the lower byte is used
  //to see what bit was shifted out of the center 16 bit CRC
  //accumulator ("carry flag analog");
  newCRC=0x00F32100;
  while(len--)
    {
    //Get the next byte in the stream.
    data=*bufptr++;
    //Push this byte's bits through a software
    //implementation of a hardware shift & xor. 
    for(bit_count=0;bit_count<=7;bit_count++)
      {
      //Shift the CRC accumulator
      newCRC>>=1;

      //The new MSB of the CRC accumulator comes
      //from the LSB of the current data byte.
      if(data&0x01)
        newCRC|=0x00800000;

      //If the low bit of the current CRC accumulator was set
      //before the shift, then we need to XOR the accumulator
      //with the polynomial (center 16 bits of 0x00840800)
      if(newCRC&0x00000080)
        newCRC^=0x00840800;
      //Shift the data byte to put the next bit of the stream
      //into position 0.
      data>>=1;
      }
    }

  //All the data has been done. Do 16 more bits of 0 data.
  for(bit_count=0;bit_count<=15;bit_count++)
    {
    //Shift the CRC accumulator
    newCRC>>=1;

    //If the low bit of the current CRC accumulator was set
    //before the shift we need to XOR the accumulator with
    //0x00840800.
    if(newCRC&0x00000080)
      newCRC^=0x00840800;
    }
  //Return the center 16 bits, making this CRC match the one's
  //complement that is sent in the packet.
  return((~newCRC)>>8);
  }

#else
//This code is from the IRDA LAP documentation, which appears to 
//have been copied from PPP:
//
// http://irda.affiniscape.com/associations/2494/files/Specifications/IrLAP11_Plus_Errata.zip
//
//I doubt that there are any worries about the legality of this code,
//searching for the first line of the table below, it appears that
//the code is already included in the linux 2.6 kernel "Driver for
//ST5481 USB ISDN modem". This is an "industry standard" algorithim
//and I do not think there are ANY issues with it at all.
word get_crc(ubyte *bufptr,word len)
  {
  //CRC lookup table to avoid bit-shifting loops.
  static const word crcLookupTable[256] =
    {0x00000,0x01189,0x02312,0x0329B,0x04624,0x057AD,0x06536,0x074BF,
     0x08C48,0x09DC1,0x0AF5A,0x0BED3,0x0CA6C,0x0DBE5,0x0E97E,0x0F8F7,
     0x01081,0x00108,0x03393,0x0221A,0x056A5,0x0472C,0x075B7,0x0643E,
     0x09CC9,0x08D40,0x0BFDB,0x0AE52,0x0DAED,0x0CB64,0x0F9FF,0x0E876,
     0x02102,0x0308B,0x00210,0x01399,0x06726,0x076AF,0x04434,0x055BD,
     0x0AD4A,0x0BCC3,0x08E58,0x09FD1,0x0EB6E,0x0FAE7,0x0C87C,0x0D9F5,
     0x03183,0x0200A,0x01291,0x00318,0x077A7,0x0662E,0x054B5,0x0453C,
     0x0BDCB,0x0AC42,0x09ED9,0x08F50,0x0FBEF,0x0EA66,0x0D8FD,0x0C974,
     0x04204,0x0538D,0x06116,0x0709F,0x00420,0x015A9,0x02732,0x036BB,
     0x0CE4C,0x0DFC5,0x0ED5E,0x0FCD7,0x08868,0x099E1,0x0AB7A,0x0BAF3,
     0x05285,0x0430C,0x07197,0x0601E,0x014A1,0x00528,0x037B3,0x0263A,
     0x0DECD,0x0CF44,0x0FDDF,0x0EC56,0x098E9,0x08960,0x0BBFB,0x0AA72,
     0x06306,0x0728F,0x04014,0x0519D,0x02522,0x034AB,0x00630,0x017B9,
     0x0EF4E,0x0FEC7,0x0CC5C,0x0DDD5,0x0A96A,0x0B8E3,0x08A78,0x09BF1,
     0x07387,0x0620E,0x05095,0x0411C,0x035A3,0x0242A,0x016B1,0x00738,
     0x0FFCF,0x0EE46,0x0DCDD,0x0CD54,0x0B9EB,0x0A862,0x09AF9,0x08B70,
     0x08408,0x09581,0x0A71A,0x0B693,0x0C22C,0x0D3A5,0x0E13E,0x0F0B7,
     0x00840,0x019C9,0x02B52,0x03ADB,0x04E64,0x05FED,0x06D76,0x07CFF,
     0x09489,0x08500,0x0B79B,0x0A612,0x0D2AD,0x0C324,0x0F1BF,0x0E036,
     0x018C1,0x00948,0x03BD3,0x02A5A,0x05EE5,0x04F6C,0x07DF7,0x06C7E,
     0x0A50A,0x0B483,0x08618,0x09791,0x0E32E,0x0F2A7,0x0C03C,0x0D1B5,
     0x02942,0x038CB,0x00A50,0x01BD9,0x06F66,0x07EEF,0x04C74,0x05DFD,
     0x0B58B,0x0A402,0x09699,0x08710,0x0F3AF,0x0E226,0x0D0BD,0x0C134,
     0x039C3,0x0284A,0x01AD1,0x00B58,0x07FE7,0x06E6E,0x05CF5,0x04D7C,
     0x0C60C,0x0D785,0x0E51E,0x0F497,0x08028,0x091A1,0x0A33A,0x0B2B3,
     0x04A44,0x05BCD,0x06956,0x078DF,0x00C60,0x01DE9,0x02F72,0x03EFB,
     0x0D68D,0x0C704,0x0F59F,0x0E416,0x090A9,0x08120,0x0B3BB,0x0A232,
     0x05AC5,0x04B4C,0x079D7,0x0685E,0x01CE1,0x00D68,0x03FF3,0x02E7A,
     0x0E70E,0x0F687,0x0C41C,0x0D595,0x0A12A,0x0B0A3,0x08238,0x093B1,
     0x06B46,0x07ACF,0x04854,0x059DD,0x02D62,0x03CEB,0x00E70,0x01FF9,
     0x0F78F,0x0E606,0x0D49D,0x0C514,0x0B1AB,0x0A022,0x092B9,0x08330,
     0x07BC7,0x06A4E,0x058D5,0x0495C,0x03DE3,0x02C6A,0x01EF1,0x00F78};

  register word
    newCrc;
  newCrc=0xFFFF;
  //This algorithim is based on the IrDA LAP example.
  while(len--)
    newCrc = (newCrc >> 8) ^ crcLookupTable[(newCrc ^ *bufptr++) & 0xff];

  //Make this crc match the one's complement that is sent in the packet.
  return(~newCrc);
  }
#endif
//============================================================================

COMMAND_PACKET
  incoming_response;

//============================================================================
//                              send_packet()
//
// send_packet() will send set the CRC in outgoing_command and send it to
// the host.
//----------------------------------------------------------------------------
void send_packet(COMMAND_PACKET *packet)
  {
  ubyte
    i;
  unsigned char
     buffer[80];
  int
    index;
  index=0;
  buffer[index++]=packet->command;
  buffer[index++]=packet->data_length;
  for(i=0;i<packet->data_length;i++)
    buffer[index++]=packet->data[i];
  //Set the CRC
  packet->CRC.as_word=
    get_crc((ubyte *)packet,packet->data_length+2);

  buffer[index++]=packet->CRC.as_bytes[0];
  buffer[index++]=packet->CRC.as_bytes[1];

  aa_i2c_write(aardvark_handle,
               ((CMy533I2C_WinTestDlg*)OurParent)->I2C_Address,
               AA_I2C_NO_FLAGS,
               index,
               (aa_u08 *)buffer);
  }
//============================================================================
//                              check_for_packet()
//
// check_for_packet() will see if there is a valid packet in the input buffer.
// If there is, it will copy it into incoming_response and return 1. If there
// is not it will return 0. incoming_packet may get partially filled with
// garbage if there is not a valid packet available.
//----------------------------------------------------------------------------
ubyte check_for_packet(void)
  {
  //Clear the return packet.
  memset(&incoming_response,0,sizeof(COMMAND_PACKET));
  //The I2C CFA-533 cannot push data to us. So instead, every time
  //we might want to look for a packet, we will do a read of the
  //outgoing packet area of the CFA-533.
  aa_i2c_read(aardvark_handle,
              ((CMy533I2C_WinTestDlg*)OurParent)->I2C_Address,
              AA_I2C_NO_FLAGS,
              sizeof(COMMAND_PACKET),
              (aa_u08 *)&incoming_response);

  //Only commands 0 through MAX_COMMAND are valid.
  if(MAX_COMMAND<(0x3F&incoming_response.command))
    return(0);
  //There is a valid command byte. Get the data_length. The data length
  //must be within reason.
  if((MAX_DATA_LENGTH)<incoming_response.data_length)
    return(0);

  //Unpack the CRC into its position.
  incoming_response.CRC.as_bytes[0]=incoming_response.data[incoming_response.data_length];
  incoming_response.CRC.as_bytes[1]=incoming_response.data[incoming_response.data_length+1];

  //Now check the CRC.
  if(incoming_response.CRC.as_word==
     get_crc((ubyte *)&incoming_response,incoming_response.data_length+2))
    {
    //This is a good packet. I'll be horn swaggled.
    //Let our caller know that incoming_response has good stuff in it.
    return(1);
    }
  //The CRC did not match.
  return(0);
  }
//============================================================================